// thumb2: anti-thumbnail hammer process patcher for Sims2 AL p1
// special thanks to rez for the patch code
//
// note: this file is PUBLIC DOMAIN
// feel free to do whatever you want with it

#include <stdio.h>
#include <string.h>

#include <windows.h>
#include <psapi.h>

int main(int argc, char *argv[])
{
	char exe_name[] = "Sims2EP8.exe";
	unsigned int addr = 0xAE7F2F;
	size_t sz = 6;
	char out[6] = { 0xE9,0x9D,0x00,0x00,0x00,0x90 };
	char old[6] = { 0x0F,0x85,0x9C,0x00,0x00,0x00 };
	char buf[6];

	DWORD aProcesses[1024], cbNeeded, cProcesses, processID = 0;
	char szProcessName[MAX_PATH];

	unsigned int i;

	// find process

	if ( EnumProcesses( aProcesses, sizeof(aProcesses), &cbNeeded ) ) {
		cProcesses = cbNeeded / sizeof(DWORD);
		for ( i = 0; i < cProcesses; i++ ) {
			HANDLE h = OpenProcess( PROCESS_QUERY_INFORMATION | PROCESS_VM_READ, FALSE, aProcesses[i] );
			if ( h != NULL ) {
				HMODULE hMod;
				DWORD cbNeeded2;
				if ( EnumProcessModules( h, &hMod, sizeof(hMod), &cbNeeded2) ) {
					GetModuleBaseName( h, hMod, szProcessName, sizeof(szProcessName) );
					if (strcmp(szProcessName, exe_name) == 0) processID = aProcesses[i];
				}
			}
			CloseHandle(h);
		}
	}

	// verify and modify

	if (processID != 0) {
		HANDLE h = OpenProcess( PROCESS_ALL_ACCESS, FALSE, processID );
		if ( h != NULL ) {
			if ( ReadProcessMemory(h, (LPCVOID) addr, buf, sz, NULL) ) {
				int x = 0;
				for (i = 0; i < sz; i++) {
					if (buf[i] != old[i]) x = 1;
				}
				if (x == 0) {
					if ( WriteProcessMemory(h, (LPVOID) addr, out, sz, NULL) ) {
						printf("thumb2: [OK] process has been patched\n");
					} else {
						printf("thumb2: process memory failed to write\n");
					}
				} else {
					printf("thumb2: process memory failed to verify\n");
				}
			} else {
				printf("thumb2: process memory failed to read\n");
			}
		} else {
			printf("thumb2: process handle failed to open\n");
		}
		CloseHandle(h);
	} else {
		printf("thumb2: cannot find %s process\n", exe_name);
	}


	system("PAUSE");
	return 0;
}
